'''Contains heuristics for sliding puzzles and Sokoban.'''

class NullHeuristic:
    '''The heuristic function that always returns 0.'''
    def __init__(self, problem):
        pass

    def eval(self, state):
        return 0

class NumMisplacedHeuristic:
    '''Gives the number of misplaced tiles.'''
    def __init__(self, problem):
        self.problem = problem

    def eval(self, state):
        curState = self.problem.getState()
        self.problem.setState(state)
        
        ######YOUR CODE BEGINS HERE######
        bound = 0 #Replace this with your code (set bound to what you want to return)
        #######YOUR CODE ENDS HERE#######

        self.problem.setState(curState)
        return bound

class ManhattanHeuristic:
    '''Gives the Manhattan distance each tile's position to its position in the goal state.'''
    def __init__(self, problem):
        self.problem = problem

    def eval(self, state):
        curState = self.problem.getState()
        self.problem.setState(state)
        
        ######YOUR CODE BEGINS HERE######
        bound = 0 #Replace this with your code (set bound to what you want to return)
        #######YOUR CODE ENDS HERE#######
        
        self.problem.setState(curState)
        return bound

class GaschnigsHeuristic:
    '''Gives the number of moves to the goal if any tile may swap with the blank tile.'''
    def __init__(self, problem):
        self.problem = problem

    def eval(self, state):
        curState = self.problem.getState()
        self.problem.setState(state)
        
        ######YOUR CODE BEGINS HERE######
        bound = 0 #Replace this with your code (set bound to what you want to return)
        #######YOUR CODE ENDS HERE#######
        
        self.problem.setState(curState)
        return bound

class ComboHeuristic:
    '''Gives the max of Manhattan and Gaschnig's.'''
    def __init__(self, problem):
        self.problem = problem
        #Put some code in here too!

    def eval(self, state):
        curState = self.problem.getState()
        self.problem.setState(state)
        
        ######YOUR CODE BEGINS HERE######
        bound = 0 #Replace this with your code (set bound to what you want to return)
        #######YOUR CODE ENDS HERE#######
        
        self.problem.setState(curState)
        return bound

class SokobanHeuristic:
    def __init__(self, problem):
        self.problem = problem
        #You may add some pre-processing code here, if you want (must be poly-time!)
        
    def eval(self, state):
        curState = self.problem.getState()
        self.problem.setState(state)
        
        ######YOUR CODE BEGINS HERE######
        bound = 0 #Replace this with your code (set bound to what you want to return)
        #######YOUR CODE ENDS HERE#######
        
        self.problem.setState(curState)
        return bound
                
